﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SORTER
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        int[] array;
        string path;

        public MainWindow()
        {
            InitializeComponent();
            //linearSelectionSort(false);
            //methodMinMax();
            //BubbleSort();
            //ShuttleSort();
            //InsertionSort();
        }


        void linearSelectionSort(bool? ordering)
        {
            List<int> arraySorted = new List<int>();
            int[] arrayCopy = new int[array.Length];

            int max = int.MinValue;
            int min = int.MaxValue;
            int index = 0;

            for (int i = 0; i < arrayCopy.Length; ++i)
            {
                arrayCopy[i] = array[i];
            }

            if (ordering == false)
            {
                using (StreamWriter sw = new StreamWriter(path, false))
                {
                    while (arraySorted.Count < 100)
                    {
                        for (int i = 0; i < arrayCopy.Length; ++i)
                        {
                            if (max <= arrayCopy[i] && arrayCopy[i] != 100)
                            {
                                max = arrayCopy[i];
                                index = i;
                            }
                        }
                        arrayCopy[index] = 100;
                        arraySorted.Add(max);
                        sw.Write(arraySorted[index] + " ");
                        max = int.MinValue;
                    }
                }
            }
            else
            {
                using (StreamWriter sw = new StreamWriter(path, false))
                {
                    while (arraySorted.Count < 100)
                    {
                        for (int i = 0; i < arrayCopy.Length; ++i)
                        {
                            if (min >= arrayCopy[i] && arrayCopy[i] != 100)
                            {
                                min = arrayCopy[i];
                                index = i;
                            }
                        }
                        arrayCopy[index] = 100;
                        arraySorted.Add(min);
                        sw.Write(arraySorted[min] + " ");
                        min = int.MaxValue;
                    }
                }
            }

            arraySorted.Clear();
        }


        void methodMinMax(bool? ordering)
        {
            if(ordering == false)
            {
                for (int i = 0; i < array.Length - 1; ++i)
                {
                    int max = i;

                    for (int j = i + 1; j < array.Length; ++j)
                    {
                        if (array[j].CompareTo(array[max]) > 0)
                        {
                            max = j;
                        }
                    }

                    int temp = array[i];
                    array[i] = array[max];
                    array[max] = temp;
                }

            }
            else
            {
                for (int i = 0; i < array.Length - 1; ++i)
                {
                    int max = i;

                    for (int j = i + 1; j < array.Length; ++j)
                    {
                        if (array[j].CompareTo(array[max]) < 0)
                        {
                            max = j;
                        }
                    }

                    int temp = array[i];
                    array[i] = array[max];
                    array[max] = temp;
                }

            }


            using (StreamWriter sw = new StreamWriter(path, false))
            {
                for (int i = 0; i < array.Length; ++i)
                {
                    sw.Write(array[i] + " ");
                }
            }
        }


        void BubbleSort(bool? ordering)
        {
            int temp;

            if (ordering == false)
            {
                for (int i = 0; i < array.Length - 1; i++)
                {
                    for (int j = 0; j < array.Length - i - 1; j++)
                    {
                        if (array[j + 1] > array[j])
                        {
                            temp = array[j + 1];
                            array[j + 1] = array[j];
                            array[j] = temp;
                        }
                    }
                }
            }
            else
            {
                for (int i = 0; i < array.Length - 1; i++)
                {
                    for (int j = 0; j < array.Length - i - 1; j++)
                    {
                        if (array[j + 1] < array[j])
                        {
                            temp = array[j + 1];
                            array[j + 1] = array[j];
                            array[j] = temp;
                        }
                    }
                }
            }

            using (StreamWriter sw = new StreamWriter(path, false))
            {
                for (int i = 0; i < array.Length; ++i)
                {
                    sw.Write(array[i] + " ");
                }
            }
        }


        void ShuttleSort(bool? ordering)
        {

            int temp;

            if(ordering == false)
            {
                for (int i = 1; i < array.Length; i++)
                {
                    if (array[i] < array[i - 1])
                    {
                        temp = array[i];
                        array[i] = array[i - 1];
                        array[i - 1] = temp;
                        for (int j = i - 1; (j - 1) >= 0; j--)
                        {
                            if (array[j] < array[j - 1])
                            {
                                temp = array[j];
                                array[j] = array[j - 1];
                                array[j - 1] = temp;
                            }
                            else
                            {
                                break;
                            }
                        }
                    }
                }
            }
            else
            {
                for (int i = 1; i < array.Length; i++)
                {
                    if (array[i] > array[i - 1])
                    {
                        temp = array[i];
                        array[i] = array[i - 1];
                        array[i - 1] = temp;
                        for (int j = i - 1; (j - 1) >= 0; j--)
                        {
                            if (array[j] > array[j - 1])
                            {
                                temp = array[j];
                                array[j] = array[j - 1];
                                array[j - 1] = temp;
                            }
                            else
                            {
                                break;
                            }
                        }
                    }
                }
            }


            using (StreamWriter sw = new StreamWriter(path, false))
            {
                for (int i = 0; i < array.Length; ++i)
                {
                    sw.Write(array[i] + " ");
                }
            }
        }


        void InsertionSort(bool? ordering)
        {

            int index, temp;

            if (ordering == false)
            {
                for (int i = 0; i < array.Length; ++i)
                {
                    index = i;
                    temp = array[i];
                    for (int j = i + 1; j < array.Length; ++j)
                    {
                        if (array[j] > temp)
                        {
                            index = j;
                            temp = array[j];
                        }
                    }
                    array[index] = array[i];
                    array[i] = temp;
                }
            }
            else
            {
                for (int i = 0; i < array.Length; ++i)
                {
                    index = i;
                    temp = array[i];
                    for (int j = i + 1; j < array.Length; ++j)
                    {
                        if (array[j] < temp)
                        {
                            index = j;
                            temp = array[j];
                        }
                    }
                    array[index] = array[i];
                    array[i] = temp;
                }
            }

            using (StreamWriter sw = new StreamWriter(path, false))
            {
                for (int i = 0; i < array.Length; ++i)
                {
                    sw.Write(array[i] + " ");
                }
            }
        }

        private void SortButton_Click(object sender, RoutedEventArgs e)
        {
            if (LinearButton.IsChecked == true)
            {
                linearSelectionSort(Ascending.IsChecked);
            }
            else if (minMaxButton.IsChecked == true)
            {
                methodMinMax(Ascending.IsChecked);
            }
            else if (BubbleButton.IsChecked == true)
            {
                BubbleSort(Ascending.IsChecked);
            }
            else if (ShuttleButton.IsChecked == true)
            {
                ShuttleSort(Ascending.IsChecked);
            }
            else if (InsertionButton.IsChecked == true)
            {
                InsertionSort(Ascending.IsChecked);
            }
        }

        private void SelectFile_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog OPF = new OpenFileDialog();
            OPF.Filter = "Файлы txt|*.txt";
            if (OPF.ShowDialog() == true)
            {
                path = OPF.FileName;

                using (StreamReader sr = new StreamReader(OPF.FileName))
                {
                    string str = sr.ReadToEnd();
                    string[] arrayStr = str.Split(" ");

                    array = new int[arrayStr.Length];

                    for (int i = 0; i < arrayStr.Length; ++i)
                    {
                        array[i] = Convert.ToInt32(arrayStr[i]);
                    }
                }
            }
        }
    }
}
